#include <IRremote.h> //Version 2.2.3

//Gerauschempfänger
int soundPinFront = A3;
int soundPinRechts = A1;
int soundPinLinks = A2;

//Ultraschallsensoren trigger
int trigger = 12; //alle

//Ultraschallsensoren echo
int echo1 = 13; //links
int echo2 = 10; //mitte
int echo3 = 8;  //rechts
//Ultraschall Empfaenger dauer
long dauer1 = 0; //links
long dauer2 = 0; //mitte
long dauer3 = 0; //rechts
//Entfernung zum Hinderniss Ultraschallsensor
long entfernung1 = 0; //links
long entfernung2 = 0; //mitte
long entfernung3 = 0; //rechts
//Stepper Links
int enableL = 7;
int stepL = 6;
int richtungL = 5;
//Stepper Rechts
int enableR = 4;
int stepR = 3;
int richtungR = 2;

//Schrittanzahl Stepper
int stepCounter;
int steps = 250;

//Infrarot Empfaenger
int IRpin = 11;
IRrecv IRreceiver(IRpin); //für die IR Übertragung
decode_results IRwert;

long ultraschallAntiRausch (int trigger,int echo)
{
  long dauer = 0;
    //Anti Rauschstörung für Ultraschallsensoren
  digitalWrite(trigger, LOW); 
  delay(5);   
    //Sendet Ultraschallsignal
  digitalWrite(trigger, HIGH);
  delay(10);
    //Abschließen des Sendens
  digitalWrite(trigger, LOW);
    //Gemessene Zeit
  return dauer = pulseIn(echo, HIGH);
}

long ultraschallEntfernungsrechner (long dauer)
{
  return((dauer)/2) / 29.1; 
}

void ultraschallAlles ()
{
  dauer1 = ultraschallAntiRausch (trigger, echo1);
  dauer2 = ultraschallAntiRausch (trigger, echo2);
  dauer3 = ultraschallAntiRausch (trigger, echo3);  
      
    // Die Zeit in den Wegumrechnen (in cm)
  entfernung1 = ultraschallEntfernungsrechner(dauer1); 
  entfernung2 = ultraschallEntfernungsrechner(dauer2);
  entfernung3 = ultraschallEntfernungsrechner(dauer3);  

    //Ausgabe
  Serial.print(entfernung1); 
  Serial.println(" cm (Entfernung Sensor 1)");
  Serial.print(entfernung2); 
  Serial.println(" cm (Entfernung Sensor 2)");
  Serial.print(entfernung3); 
  Serial.println(" cm (Entfernung Sensor 3)");
}

void stepperVorwaerts ()
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
  {
    // Vorwaerts
    digitalWrite(richtungL,LOW); 
    digitalWrite(richtungR, LOW);
 
    digitalWrite(stepL,LOW);
    digitalWrite(stepR, LOW);
      
    delayMicroseconds(1000);
      
    digitalWrite(stepL,HIGH);
    digitalWrite(stepR, HIGH);
      
    delayMicroseconds(1000);
  }
}

void stepperRueckwaerts ()
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
            // Rueckwerts
          digitalWrite(richtungL,HIGH); 
          digitalWrite(richtungR, HIGH);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

void stepperDrehenRechts ()
{
    for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
           // Drehen im Kreis
          digitalWrite(richtungL,LOW); 
          digitalWrite(richtungR, HIGH);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

void stepperDrehenLinks ()
{
  for(stepCounter = 0; stepCounter < steps; ++stepCounter)
        {
            // Drehen im Kreis
          digitalWrite(richtungL,HIGH); 
          digitalWrite(richtungR, LOW);
 
          digitalWrite(stepL,LOW);
          digitalWrite(stepR, LOW);
      
          delayMicroseconds(1000);
      
          digitalWrite(stepL,HIGH);
          digitalWrite(stepR, HIGH);
      
          delayMicroseconds(1000);
        }
}

void setup() {
  Serial.begin(9600);                     
    //Ultraschallsensoren
  pinMode(trigger, OUTPUT);              
  pinMode(echo1, INPUT);                
  pinMode(echo2, INPUT);                
  pinMode(echo3, INPUT);     
   //Stepper Links
  pinMode(enableL, OUTPUT); // Enable
  pinMode(stepL, OUTPUT); // Step
  pinMode(richtungL, OUTPUT); // Richtung
   //Stepper Rechts
  pinMode(enableR, OUTPUT); // Enable
  pinMode(stepR, OUTPUT); // Step
  pinMode(richtungR, OUTPUT); // Richtung
 
  digitalWrite(7,LOW);
  digitalWrite(4,LOW);

  //IR Empfaenger
  pinMode(IRpin, INPUT);
  IRreceiver.enableIRIn();
  
}

void loop() {
      
      int SoundF = analogRead(soundPinFront);
      int SoundR = analogRead(soundPinRechts);
      int SoundL = analogRead(soundPinLinks);

      Serial.println(SoundF);
      Serial.println(SoundR);
      Serial.println(SoundL);

          ultraschallAlles ();

            //Richtungsänderungen wenn zu nah am Hindernis
          if (entfernung1 < 30 && entfernung1 != 0)
          {
            stepperDrehenRechts ();
          }
          else if (entfernung2 < 30 && entfernung2 != 0)
          {
            stepperRueckwaerts ();
          }

          else if (entfernung3 < 30 && entfernung3 != 0)
          {
            stepperDrehenLinks ();    
          }else { stepperDrehenLinks (); }
         
  delay(1000);   
}
